org.ajax4jsf.util.base64

## Class URL64Codec

- java.lang.Object
- - org.ajax4jsf.util.base64.URL64Codec

- All Implemented Interfaces:
    BinaryDecoder, BinaryEncoder, Decoder, Encoder

      public class URL64Codec
      extends Object
      implements BinaryEncoder, BinaryDecoder

  Provides Base64 encoding and decoding like defined by RFC 2045, but with little difference : chars '=' '+' and '/' , incorrectly processed in URL by any browsers, replaced by '_' '-' '!',
  Since:
    1.0-dev
  Version:
    $Id: URL64Codec.java,v 1.1.2.1 2007/01/09 18:59:11 alexsmirnov Exp $
  Author:
    Apache Software Foundation
  See Also:
    RFC 2045

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `URL64Codec()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `byte[]` | `decode(byte[] pArray)` Decodes a byte[] containing containing characters in the Base64 alphabet.
    `Object` | `decode(Object pObject)` Decodes an Object using the base64 algorithm.
    `static byte[]` | `decodeBase64(byte[] base64Data)` Decodes Base64 data into octects
    `byte[]` | `encode(byte[] pArray)` Encodes a byte[] containing binary data, into a byte[] containing characters in the Base64 alphabet.
    `Object` | `encode(Object pObject)` Encodes an Object using the base64 algorithm.
    `static byte[]` | `encodeBase64(byte[] binaryData)` Encodes binary data using the base64 algorithm but does not chunk the output.
    `static byte[]` | `encodeBase64(byte[] binaryData, boolean isChunked)` Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.
    `static byte[]` | `encodeBase64Chunked(byte[] binaryData)` Encodes binary data using the base64 algorithm and chunks the encoded output into 76 character blocks
    `static boolean` | `isArrayByteBase64(byte[] arrayOctect)` Tests a given byte array to see if it contains only valid characters within the Base64 alphabet.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### URL64Codec

          public URL64Codec()

  - ### Method Detail

    - #### isArrayByteBase64

          public static boolean isArrayByteBase64(byte[] arrayOctect)

      Tests a given byte array to see if it contains only valid characters within the Base64 alphabet.
      Parameters:
        `arrayOctect` - byte array to test
      Returns:
        true if all bytes are valid characters in the Base64 alphabet or if the byte array is empty; false, otherwise

    - #### encodeBase64

          public static byte[] encodeBase64(byte[] binaryData)

      Encodes binary data using the base64 algorithm but does not chunk the output.
      Parameters:
        `binaryData` - binary data to encode
      Returns:
        Base64 characters

    - #### encodeBase64Chunked

          public static byte[] encodeBase64Chunked(byte[] binaryData)

      Encodes binary data using the base64 algorithm and chunks the encoded output into 76 character blocks
      Parameters:
        `binaryData` - binary data to encode
      Returns:
        Base64 characters chunked in 76 character blocks

    - #### decode

          public Object decode(Object pObject)
                        throws DecoderException

      Decodes an Object using the base64 algorithm. This method is provided in order to satisfy the requirements of the Decoder interface, and will throw a DecoderException if the supplied object is not of type byte[].
      Specified by:
        `decode` in interface `Decoder`
      Parameters:
        `pObject` - Object to decode
      Returns:
        An object (of type byte[]) containing the binary data which corresponds to the byte[] supplied.
      Throws:
        `DecoderException` - if the parameter supplied is not of type byte[]

    - #### decode

          public byte[] decode(byte[] pArray)

      Decodes a byte[] containing containing characters in the Base64 alphabet.
      Specified by:
        `decode` in interface `BinaryDecoder`
      Parameters:
        `pArray` - A byte array containing Base64 character data
      Returns:
        a byte array containing binary data

    - #### encodeBase64

          public static byte[] encodeBase64(byte[] binaryData,
                                            boolean isChunked)

      Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.
      Parameters:
        `binaryData` - Array containing binary data to encode.
        `isChunked` - if isChunked is true this encoder will chunk the base64 output into 76 character blocks
      Returns:
        Base64-encoded data.

    - #### decodeBase64

          public static byte[] decodeBase64(byte[] base64Data)

      Decodes Base64 data into octects
      Parameters:
        `base64Data` - Byte array containing Base64 data
      Returns:
        Array containing decoded data.

    - #### encode

          public Object encode(Object pObject)
                        throws EncoderException

      Encodes an Object using the base64 algorithm. This method is provided in order to satisfy the requirements of the Encoder interface, and will throw an EncoderException if the supplied object is not of type byte[].
      Specified by:
        `encode` in interface `Encoder`
      Parameters:
        `pObject` - Object to encode
      Returns:
        An object (of type byte[]) containing the base64 encoded data which corresponds to the byte[] supplied.
      Throws:
        `EncoderException` - if the parameter supplied is not of type byte[]

    - #### encode

          public byte[] encode(byte[] pArray)

      Encodes a byte[] containing binary data, into a byte[] containing characters in the Base64 alphabet.
      Specified by:
        `encode` in interface `BinaryEncoder`
      Parameters:
        `pArray` - a byte array containing binary data
      Returns:
        A byte array containing only Base64 character data

Copyright © 2015 JBoss by Red Hat. All Rights Reserved.